/****************************************************************************
** SourceFileEntry - class
**
** Created: Thu Jun 10 12:09:08 2004
**      by: Varol Okan using kate editor
**
** This class will use the xineEngine to obtain information about the 
** stream currently set by this engine.
**
****************************************************************************/

#ifndef MPLAYERINFO_H
#define MPLAYERINFO_H

#include <qobject.h>
#include <qimage.h>

#include "../mediainfo.h"

class QProcess;

class MPlayerInfo : public QObject, public MediaInfo
{
	Q_OBJECT
public:
	MPlayerInfo ();
	MPlayerInfo (void *);
	virtual ~MPlayerInfo ();

	// Mandatory function getScreenshot ()
	virtual QImage getScreenshot(uint s=0);

	// Non-standard functions (not implemented through MediaInfo ...)
	virtual bool hasChapters ();
protected:
	// Mandatory function queryValues ()
	virtual void queryValues ();

protected slots:
	virtual void slotReadStdout     ();

private:
	// Private member variables
	QProcess *m_pSlaveProcess;
	QString   m_qsTempPathName;
};

#endif	// MPLAYERINFO_H

